Panda3D

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
LwoSurface Class Reference

Describes the shading attributes of a surface. More...

`#include "lwoSurface.h"`

Inheritance diagram for LwoSurface:

## Public Member Functions
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
virtual IffChunk * | make_new_chunk (IffInputFile *in, IffId id)
| Allocates and returns a new chunk of the appropriate type based on the given ID, according to the context given by this chunk itself. More...
virtual bool | read_iff (IffInputFile *in, size_t stop_at)
| Reads the data of the chunk in from the given input file, if possible. More...
virtual void | write (std::ostream &out, int indent_level=0) const
Public Member Functions inherited from LwoGroupChunk
IffChunk * | get_chunk (int n) const
| Returns the nth child chunk of this group. More...
int | get_num_chunks () const
| Returns the number of child chunks of this group. More...
Public Member Functions inherited from IffChunk
IffId | get_id () const
| Returns the ID associated with this chunk. More...
virtual void | output (std::ostream &out) const
void | set_id (IffId id)
| Changes the ID associated with this chunk. More...
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from LwoGroupChunk
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from LwoChunk
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from IffChunk
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
std::string | _name
std::string | _source
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Detailed Description

Describes the shading attributes of a surface.

This is similar to the concept usually called a "material" or "shader" in other file formats.

Definition at line 25 of file lwoSurface.h.

## Member Function Documentation

## ◆ make_new_chunk()

IffChunk * LwoSurface::make_new_chunk | ( | IffInputFile * | in,
|  | IffId | id
| ) |  |
| virtual

Allocates and returns a new chunk of the appropriate type based on the given ID, according to the context given by this chunk itself.

Reimplemented from IffChunk.

Definition at line 58 of file lwoSurface.cxx.

References IffChunk::make_new_chunk().

## ◆ read_iff()

bool LwoSurface::read_iff | ( | IffInputFile * | in,
|  | size_t | stop_at
| ) |  |
| virtual

Reads the data of the chunk in from the given input file, if possible.

The ID and length of the chunk have already been read. stop_at is the byte position of the file to stop at (based on the current position at in->get_bytes_read()). Returns true on success, false otherwise.

Implements IffChunk.

Definition at line 32 of file lwoSurface.cxx.

References IffInputFile::get_string().

The documentation for this class was generated from the following files:

- pandatool/src/lwo/lwoSurface.h
- pandatool/src/lwo/lwoSurface.cxx